## ros-foxy-rclpy 1.0.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclpy)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(rcl REQUIRED)
find_package(rcl_action REQUIRED)
find_package(rcl_yaml_param_parser REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

find_package(python_cmake_module REQUIRED)
find_package(PythonExtra MODULE REQUIRED)

set(_PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}")

if(WIN32 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE_DEBUG}")
endif()

# enables using the Python extensions from the build space for testing
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/test_rclpy/__init__.py" "")

ament_python_install_package(${PROJECT_NAME})

function(set_properties _targetname _build_type)
  set_target_properties(${_targetname} PROPERTIES
    PREFIX ""
    LIBRARY_OUTPUT_DIRECTORY${_build_type} "${CMAKE_CURRENT_BINARY_DIR}/test_${PROJECT_NAME}"
    RUNTIME_OUTPUT_DIRECTORY${_build_type} "${CMAKE_CURRENT_BINARY_DIR}/test_${PROJECT_NAME}"
    OUTPUT_NAME "_${_targetname}${PythonExtra_EXTENSION_SUFFIX}"
    SUFFIX "${PythonExtra_EXTENSION_EXTENSION}")
endfunction()

# Only build the library if a C typesupport exists
get_rmw_typesupport(typesupport_impls "rmw_implementation" LANGUAGE "c")
if(typesupport_impls STREQUAL "")
  message(STATUS "Skipping rclpy because no C typesupport library was found.")
  return()
endif()

function(configure_python_c_extension_library _library_name)
  set_properties(${_library_name} "")
  if(WIN32)
    set_properties(${_library_name} "_DEBUG")
    set_properties(${_library_name} "_MINSIZEREL")
    set_properties(${_library_name} "_RELEASE")
    set_properties(${_library_name} "_RELWITHDEBINFO")
  endif()

  target_link_libraries(${_library_name}
    ${PythonExtra_LIBRARIES}
  )

  ament_target_dependencies(${_library_name}
    "PythonExtra"
  )

  install(TARGETS ${_library_name}
    DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}"
  )
endfunction()

add_library(rclpy_common SHARED
  src/rclpy_common/src/common.c
  src/rclpy_common/src/handle.c
)
target_link_libraries(rclpy_common
  ${PythonExtra_LIBRARIES}
)
target_include_directories(rclpy_common
  PUBLIC
  src/rclpy_common/include
)
ament_target_dependencies(rclpy_common
  "rcl"
  "rmw"
  "PythonExtra"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(rclpy_common PRIVATE "RCLPY_COMMON_BUILDING_DLL")

install(TARGETS rclpy_common
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

add_library(rclpy SHARED
  src/rclpy/_rclpy.c
  src/rclpy/detail/execute_with_logging_mutex.cpp
  src/rclpy/detail/logging_mutex.cpp
  src/rclpy/detail/thread_safe_logging_output_handler.cpp
)
target_link_libraries(rclpy
  rclpy_common
)

configure_python_c_extension_library(rclpy)
ament_target_dependencies(rclpy
  "rcl"
  "rcl_yaml_param_parser"
  "rcutils"
)

add_library(
  rclpy_action
  SHARED src/rclpy/_rclpy_action.c
)
target_link_libraries(rclpy_action
  rclpy_common
)

configure_python_c_extension_library(rclpy_action)
ament_target_dependencies(rclpy_action
  "rcl"
  "rcl_action"
  "rcutils"
)

# Logging support provided by rcutils
add_library(
  rclpy_logging
  SHARED src/rclpy/_rclpy_logging.c
)
configure_python_c_extension_library(rclpy_logging)
ament_target_dependencies(rclpy_logging
  "rcutils"
)

# Signal handling library
add_library(
  rclpy_signal_handler
  SHARED src/rclpy/_rclpy_signal_handler.c
)
target_link_libraries(rclpy_signal_handler
  rclpy_common
)
configure_python_c_extension_library(rclpy_signal_handler)
ament_target_dependencies(rclpy_signal_handler
  "rcl"
  "rcutils"
)

# Pycapsule handling library
add_library(
  rclpy_pycapsule
  SHARED src/rclpy/_rclpy_pycapsule.c
)
configure_python_c_extension_library(rclpy_pycapsule)

# Handle library, used to keep dependencies between C objects.
add_library(
  rclpy_handle
  SHARED src/rclpy/_rclpy_handle.c
)
target_link_libraries(rclpy_handle
  rclpy_common
)
configure_python_c_extension_library(rclpy_handle)
ament_target_dependencies(rclpy_handle
  "rcutils"
)

if(NOT WIN32)
  ament_environment_hooks(
    "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
  )
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_pytest REQUIRED)
  find_package(rosidl_generator_py REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)

  rosidl_generator_py_get_typesupports(_typesupport_impls)
  ament_index_get_prefix_path(ament_index_build_path SKIP_AMENT_PREFIX_PATH)
  # Get the first item (it will be the build space version of the build path).
  list(GET ament_index_build_path 0 ament_index_build_path)
  if(WIN32)
    # On Windows prevent CMake errors and prevent it being evaluated as a list.
    string(REPLACE "\\" "/" ament_index_build_path "${ament_index_build_path}")
  endif()

  ament_add_gtest(test_c_handle
    src/test/rclpy_common/test_handle.cpp)
  target_link_libraries(test_c_handle
    rclpy_common)

  if(NOT _typesupport_impls STREQUAL "")
    # Run each test in its own pytest invocation to isolate any global state in rclpy
    set(_rclpy_pytest_tests
      test/test_action_client.py
      test/test_action_graph.py
      test/test_action_server.py
      test/test_callback_group.py
      test/test_client.py
      test/test_clock.py
      test/test_create_node.py
      test/test_create_while_spinning.py
      test/test_destruction.py
      test/test_executor.py
      test/test_expand_topic_name.py
      test/test_guard_condition.py
      test/test_handle.py
      test/test_init_shutdown.py
      test/test_logging.py
      test/test_logging_rosout.py
      test/test_messages.py
      test/test_node.py
      test/test_parameter.py
      test/test_parameters_callback.py
      test/test_publisher.py
      test/test_qos.py
      test/test_qos_event.py
      test/test_rate.py
      test/test_serialization.py
      test/test_subscription.py
      test/test_task.py
      test/test_time_source.py
      test/test_time.py
      test/test_timer.py
      test/test_topic_or_service_is_hidden.py
      test/test_topic_endpoint_info.py
      test/test_utilities.py
      test/test_validate_full_topic_name.py
      test/test_validate_namespace.py
      test/test_validate_node_name.py
      test/test_validate_topic_name.py
      test/test_waitable.py
    )

    foreach(_test_path ${_rclpy_pytest_tests})
      get_filename_component(_test_name ${_test_path} NAME_WE)
      ament_add_pytest_test(${_test_name} ${_test_path}
        PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}"
        APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}
          PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}
        TIMEOUT 120
        WERROR ON
      )
    endforeach()
  endif()
endif()
set(PYTHON_EXECUTABLE "${_PYTHON_EXECUTABLE}")

ament_package()

=== debian/changelog ===
ros-foxy-rclpy (1.0.13-1focal) focal; urgency=high

  * Fix #983 <https://github.com/ros2/rclpy/issues/983> by saving future and checking for + raising any exceptions (#1073 <https://github.com/ros2/rclpy/issues/1073>) (#1116 <https://github.com/ros2/rclpy/issues/1116>)
  * Contributors: Achille Verheye, Tomoya Fujita

 -- William Woodall <william@osrfoundation.org>  Sat, 27 May 2023 00:00:00 -0000

ros-foxy-rclpy (1.0.12-1focal) focal; urgency=high

  * Fix test_publisher linter for pydocstyle 6.2.2 (#1063 <https://github.com/ros2/rclpy/issues/1063>) (#1068 <https://github.com/ros2/rclpy/issues/1068>)
  * Waitable should check callback_group if it can be executed. (#1001 <https://github.com/ros2/rclpy/issues/1001>) (#1015 <https://github.com/ros2/rclpy/issues/1015>)
  * Contributors: mergify[bot], Cristóbal Arroyo, Tomoya Fujita

 -- William Woodall <william@osrfoundation.org>  Thu, 16 Mar 2023 00:00:00 -0000

ros-foxy-rclpy (1.0.11-1focal) focal; urgency=high

  * Revert "Raise user handler exception in MultiThreadedExecutor. (#984 <https://github.com/ros2/rclpy/issues/984>)" (#1017 <https://github.com/ros2/rclpy/issues/1017>) (#1021 <https://github.com/ros2/rclpy/issues/1021>)
  * Contributors: Tomoya Fujita, mergify[bot]

 -- William Woodall <william@osrfoundation.org>  Wed, 12 Oct 2022 00:00:00 -0000

ros-foxy-rclpy (1.0.10-1focal) focal; urgency=high

  * Raise user handler exception in MultiThreadedExecutor (#984 <https://github.com/ros2/rclpy/issues/984>) (#992 <https://github.com/ros2/rclpy/issues/992>)
  * Contributors: Tomoya Fujita

 -- William Woodall <william@osrfoundation.org>  Mon, 12 Sep 2022 00:00:00 -0000

ros-foxy-rclpy (1.0.9-1focal) focal; urgency=high

  * Add __enter__ and __exit__ to Waitable (#761 <https://github.com/ros2/rclpy/issues/761>) (#998 <https://github.com/ros2/rclpy/issues/998>)
  * Remove feedback callback when the goal has been completed (#927 <https://github.com/ros2/rclpy/issues/927>) (#933 <https://github.com/ros2/rclpy/issues/933>)
  * Fix memory leak for get_(publishers|subscriptions)_info_by_topic (#955 <https://github.com/ros2/rclpy/issues/955>)
  * Fix type annotation for get_parameters_by_prefix (#964 <https://github.com/ros2/rclpy/issues/964>)
  * Fix rclpy.duration.Duration.to_msg() losing precision (#876 <https://github.com/ros2/rclpy/issues/876>) (#917 <https://github.com/ros2/rclpy/issues/917>)
  * Fix inverted error code for action client take (#949 <https://github.com/ros2/rclpy/issues/949>)
  * Fix memory leak for serialization (#898 <https://github.com/ros2/rclpy/issues/898>)
  * Fix crash on spinning raw subscription when publishes closes (#827 <https://github.com/ros2/rclpy/issues/827>). (#903 <https://github.com/ros2/rclpy/issues/903>)
  * Contributors: Chen Lihui, Chris Lalancette, Erki Suurjaak, HyunSeok Kil, Jonathan Chapple, Shane Loretz, Tully Foote, Tomoya Fujita

 -- William Woodall <william@osrfoundation.org>  Thu, 01 Sep 2022 00:00:00 -0000

ros-foxy-rclpy (1.0.8-1focal) focal; urgency=high

  * Adding wake_executor to subscriber (#855 <https://github.com/ros2/rclpy/issues/855>)
  * Contributors: Leonardo Oliveira Wellausen

 -- William Woodall <william@osrfoundation.org>  Mon, 31 Jan 2022 00:00:00 -0000

ros-foxy-rclpy (1.0.7-1focal) focal; urgency=high

  * Only add one done callback to a future (#816 <https://github.com/ros2/rclpy/issues/816>) (#820 <https://github.com/ros2/rclpy/issues/820>)
  * Contributors: Shane Loretz

 -- William Woodall <william@osrfoundation.org>  Tue, 05 Oct 2021 00:00:00 -0000

ros-foxy-rclpy (1.0.6-1focal) focal; urgency=high

  * Reject cancel request if failed to transit to CANCEL_GOAL state (#791 <https://github.com/ros2/rclpy/issues/791>) (#796 <https://github.com/ros2/rclpy/issues/796>)
  * Break log function execution ASAP if configured severity is too high (#776 <https://github.com/ros2/rclpy/issues/776>) (#784 <https://github.com/ros2/rclpy/issues/784>)
  * Contributors: Jacob Perron, Tomoya Fujita, ksuszka

 -- William Woodall <william@osrfoundation.org>  Tue, 31 Aug 2021 00:00:00 -0000

ros-foxy-rclpy (1.0.5-1focal) focal; urgency=high

  * [documentation] Use only True to avoid confusion in autodoc config
    None and True have the same meaning:
    https://www.sphinx-doc.org/en/master/usage/extensions/autodoc.html?highlight=autoclass#confval-autodoc_default_options
  * [documentation] Document QoS profile constants
  * Fix Enum not being comparable with ints in get_parameter_types service (#644 <https://github.com/ros2/rclpy/issues/644>)
  * Make sure to catch the ROSInterruptException when calling rate.sleep (#650 <https://github.com/ros2/rclpy/issues/650>)
  * Fix memory leak (#643 <https://github.com/ros2/rclpy/issues/643>) (#646 <https://github.com/ros2/rclpy/issues/646>)
  * Destroy event handlers owned by publishers/subscriptions when calling publisher.destroy()/subscription.destroy() (#603 <https://github.com/ros2/rclpy/issues/603>) (#625 <https://github.com/ros2/rclpy/issues/625>)
  * Use absolute parameter events topic name (#612 <https://github.com/ros2/rclpy/issues/612>) (#614 <https://github.com/ros2/rclpy/issues/614>)
  * MultiThreadedExecutor spin_until_future complete should not continue waiting when the future is done (#605 <https://github.com/ros2/rclpy/issues/605>) (#626 <https://github.com/ros2/rclpy/issues/626>)
  * Contributors: Chen Lihui Chris Lalancette, Gökçe Aydos, Ivan Santiago Paunovic, Jacob Perron, Tomoya Fujita

 -- William Woodall <william@osrfoundation.org>  Tue, 05 Jan 2021 00:00:00 -0000

ros-foxy-rclpy (1.0.4-1focal) focal; urgency=high

  * Wrap lines to shorten line length (#586 <https://github.com/ros2/rclpy/issues/586>)
  * Improve error message if rclpy C extensions are not found (#580 <https://github.com/ros2/rclpy/issues/580>)
  * Fix moved troubleshooting URL (#579 <https://github.com/ros2/rclpy/issues/579>)


=== debian/control ===
Source: ros-foxy-rclpy
Section: misc
Priority: optional
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), python3-pytest <!nocheck>, ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ament-cmake-pytest <!nocheck>, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-python-cmake-module, ros-foxy-rcl, ros-foxy-rcl-action, ros-foxy-rcl-yaml-param-parser, ros-foxy-rcutils, ros-foxy-rmw-implementation, ros-foxy-rmw-implementation-cmake, ros-foxy-rosidl-generator-py <!nocheck>, ros-foxy-test-msgs <!nocheck>, ros-foxy-unique-identifier-msgs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rclpy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-index-python, ros-foxy-builtin-interfaces, ros-foxy-rcl, ros-foxy-rcl-action, ros-foxy-rcl-interfaces, ros-foxy-rcl-yaml-param-parser, ros-foxy-rmw-implementation, ros-foxy-rosgraph-msgs, ros-foxy-rpyutils, ros-foxy-unique-identifier-msgs, ros-foxy-ros-workspace
Description: Package containing the Python client.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rclpy//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
